package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLLocalSpace_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLLocalSpace extends JNIObject implements IISLSingleSpaceReadOnlySetMethods, IISLSingleSpaceReadOnlyMapMethods {
	
	/* @generated */
	protected ISLLocalSpace(long ptr) {
		/*** PROTECTED REGION ID(ISLLocalSpace_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLLocalSpace build(long ptr) {
		return new ISLLocalSpace(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLLocalSpace_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_local_space_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_local_space_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_local_space_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_local_space_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_local_space_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_copy 
	 * 
	 * @generated
	**/
	public ISLLocalSpace copy() {
		/*** PROTECTED REGION ID(isl_local_space_copy) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_local_space_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_local_space_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_is_params 
	 * 
	 * @generated
	**/
	public boolean isParamSpace() {
		/*** PROTECTED REGION ID(isl_local_space_is_params) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_local_space_is_params(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_is_set 
	 * 
	 * @generated
	**/
	public boolean isSetSpace() {
		/*** PROTECTED REGION ID(isl_local_space_is_set) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_local_space_is_set(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_local_space_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_local_space_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_local_space_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_local_space_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_local_space_set_dim_name) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_has_dim_name 
	 * 
	 * @generated
	**/
	public boolean hasDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_local_space_has_dim_name) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_local_space_has_dim_name(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_get_div 
	 * 
	 * @generated
	**/
	public ISLAff getDivAt(int pos) {
		/*** PROTECTED REGION ID(isl_local_space_get_div) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_local_space_get_div(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLLocalSpace ls2) {
		/*** PROTECTED REGION ID(isl_local_space_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_local_space_is_equal(getNativePtr(this), getNativePtr(ls2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace domain() {
		/*** PROTECTED REGION ID(isl_local_space_domain) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace range() {
		/*** PROTECTED REGION ID(isl_local_space_range) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_from_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace toMapSpaceFromSetSpaceAsDomain() {
		/*** PROTECTED REGION ID(isl_local_space_from_domain) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_from_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_set_from_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace toSetSpaceFromParamSpace() {
		/*** PROTECTED REGION ID(isl_local_space_set_from_params) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_set_from_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_flatten_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace flattenDomain() {
		/*** PROTECTED REGION ID(isl_local_space_flatten_domain) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_flatten_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_flatten_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace flattenRange() {
		/*** PROTECTED REGION ID(isl_local_space_flatten_range) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_flatten_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_lifting 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap lifting() {
		/*** PROTECTED REGION ID(isl_local_space_lifting) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_local_space_lifting(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_local_space_add_dims) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace insertDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_local_space_insert_dims) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_insert_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_local_space_drop_dims) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_intersect 
	 * 
	 * @take this ls2
	 * @generated
	**/
	public ISLLocalSpace intersect(ISLLocalSpace ls2) {
		/*** PROTECTED REGION ID(isl_local_space_intersect) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this, ls2);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_intersect(getNativePtr(this), getNativePtr(ls2)));
			} finally {
				taken(this);
				taken(ls2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_local_space_wrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLLocalSpace wrap() {
		/*** PROTECTED REGION ID(isl_local_space_wrap) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLLocalSpace.build(ISLNative.isl_local_space_wrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLLocalSpace_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
